(in-package  :custom)
(use-package :oli)

(sd-defdialog 'Gewicht-suchen-dialog
:dialog-title "Gewicht suchen"
:toolbox-button t
:variables
  '((bgr   :value-type :assembly
           :modifies nil
           :multiple-items nil
           :prompt-text "Baugruppe angeben."
           :title "Baugruppe"
           :initial-value nil
    )
    ("Suche nach kg")
    (massu :value-type :number
           :prompt-text "Unteren Wert eingeben."
           :title "Gewicht von"
           :initial-value 1
    )
    (masso :value-type :number
           :prompt-text "Oberen Wert eingeben."
           :title "Gewicht bis"
           :initial-value 1
    )
    (teil  :value-type :part
           :modifies nil
           :multiple-items nil
           :prompt-text "Teil, dessen Gewicht uebernommen werden soll angeben."
           :title "bern. v. Teil"
           :initial-value nil
           :initial-optional t
           :after-input
           (after-teil-action)
    )
    ("-")
    ("Suchergebnis anzeigen")
    (anzeig :value-type :boolean
            :toggle-type :wide-toggle
            :title "im Darstellungs-Fenster"
            :initial-value t
    )
    (disp   :value-type :boolean
            :toggle-type :wide-toggle
            :title "im Ausgabe-Display"
            :initial-value nil
    )
    (table  :value-type :boolean
            :toggle-type :wide-toggle
            :title "in Tabelle"
            :initial-value nil
    )
    ("-")
    (next  :push-action
           (sd-call-cmds
             (next-action)
           )
           :toggle-type :wide-toggle
           :title "Ausfhren"
    )
   )
:local-functions
  '((after-teil-action ()
     (let ()
      (setf massu (sd-call-cmds (get_vol_prop :for_part :part teil :select_done :tol :rough_tol :mass)))
      (setf masso (sd-call-cmds (get_vol_prop :for_part :part teil :select_done :tol :rough_tol :mass)))
     )
    )
    (next-action ()
     (if anzeig
       (progn
         (remove_from_vp_drawlist (oli::sd-inq-current-vp) :recursive :all_at_top)
         (dc4-suche-Gewicht-in-bgr bgr massu masso anzeig disp table)
         (fit_vp (oli::sd-inq-current-vp))
       )
       (progn
         (sd-destroy-display-table "Gewicht.dtab")
         (custom::Gewicht-tabelle-erstellen)
         (dc4-suche-Gewicht-in-bgr bgr massu masso anzeig disp table)
       )
     )
    )
   )
:ok-action
   '(next-action)
)



(defun dc4-suche-Gewicht-in-bgr (teil_bgr massu masso anzeig disp table)
  (let (teiletyp kind kinder teilmass)
    (setf teiletyp (sel_item-type teil_bgr))
    (if (equal teiletyp *sd-part-seltype*)
      (progn
        (setf teilmass (sd-call-cmds (get_vol_prop :for_part :part teil_Bgr :select_done :tol :rough_tol :mass)))
        (when (and (<= massu teilmass)
                 (>= masso teilmass)
             )
          (progn
            (when anzeig
              (progn
                (add_to_vp_drawlist (oli::sd-inq-current-vp) teil_bgr)
              )
            )
            (when disp
              (display (format nil "Gewicht ~a fr Teil: --> ~a" teilmass (sd-inq-obj-basename teil_bgr)))
            )
            (when table
              (setf Eintrag (list teilmass (sd-inq-obj-pathname teil_bgr)))
              (sd-insert-logical-table-row "Gewicht.ltab" :contents Eintrag)
              (sd-show-display-table "Gewicht.dtab" :position '("TOP-MENU-TOOLBOX-TB" :bottomleft 20 20))
            )
          )
        )
      )
      (when (equal teiletyp *sd-assembly-seltype*)
        (progn
          (setf kinder (sd-inq-obj-children teil_bgr))
          (dolist (kind kinder)
            (dc4-suche-Gewicht-in-bgr kind massu masso anzeig disp table)
          )
        )
      )
    )
  )
)


(defun Gewicht-tabelle-erstellen ()
 (let ()
  (progn
   (sd-create-logical-table "Gewicht.ltab"
    :secured               nil
    :columns               '(:Gewicht :Model)
    :columnNames           '("Gewicht" "Modellname")
    :types                 '(:number :string)
    :units                 'nil
    :contents              '()
   )
   (sd-create-display-table "Gewicht.dtab"
    :tableTitle            "Gewicht suchen"
    :logicalTable          "Gewicht.ltab"
    :columns               '(:Gewicht :Model)
    :applyColumns          '(:Gewicht :Model)
    :displayWidth          600
    :displayHeight         300
    :filterStatusLine      nil
    :selectionMode         :single-row
    ;;:applyAction           :default-tokens ;;default
   )
  )
 )
)
